// De.dll v0.0.02 Copyright(C) 2002 thejam79, 2003 minamina
// Avisynth Plugin - DeDot (YUY2 and YV12 Only, DeDot 0.3 base)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _DE_DOT_H
#define _DE_DOT_H

#ifdef _MSC_VER
  #include <crtdbg.h>
#else
  #define _ASSERTE(x) assert(x)
  #include <assert.h>
#endif

#include <windows.h>
#include <memory.h>
#include <math.h>
#include <assert.h>
#pragma warning (push, 3)
#include <boost/shared_ptr.hpp>
#include <boost/lexical_cast.hpp>
#include "avisynth.h"
#pragma warning (pop)
//#include "synth.h"
#define USE_MMX2 	_asm { emms } _asm { sfence }

class DeDot : public GenericVideoFilter
{
private:
	int m_nLuma2d;
	int m_nLumaT;
	int m_nChromaT1;
	int m_nChromaT2;

	inline int clipFrame(int n) {
		return max(0, min(n, vi.num_frames - 1));
	}
	inline const unsigned char* SYP(PVideoFrame &pv, int y, int plane = PLANAR_Y) {
		return pv->GetReadPtr(plane) + y * pv->GetPitch(plane);
	}
	inline unsigned char* DYP(PVideoFrame &pv, int y, int plane = PLANAR_Y) {
		return pv->GetWritePtr(plane) + y * pv->GetPitch(plane);
	}

public:
	static void PluginInit(IScriptEnvironment *env)
	{ env->AddFunction(GetName(), GetParams(), Create, 0); }

	DeDot(PClip _child, const int nLuma2d, const int nLumaT, const int nChromaT1, const int nChromaT2, IScriptEnvironment* env);

private:
	static AVSValue __cdecl Create(AVSValue args, void* /*user_data*/, IScriptEnvironment *env)
	{ return new DeDot(args[0].AsClip(), args[1].AsInt(20), args[2].AsInt(20), args[3].AsInt(15), args[4].AsInt(5), env); }
	static const char *GetName() { return "DeDot"; }
	static const char *GetParams() { return "c[luma2d]i[lumaT]i[chromaT1]i[chromaT2]i"; }

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
	PVideoFrame DeDot_YUY2(int n, IScriptEnvironment *env);
	PVideoFrame DeDot_YV12(int n, IScriptEnvironment *env);
};

#endif // _DE_DOT_H
